﻿using System;

namespace czerwiec_2023_problem_1_sito_eratostenesa
{
    internal class Program
    {
        //rozmiar
        static int n;
        //tablica prawda/ fałsz
        static bool[] t;

        static void Wykreslaj(bool[] tab,int n)
        {
            //pierwiastkuj i zaokrąglij do całkowitej
            //niewiększej niż pierwiastek z rozmiaru
            int granica=(int)Math.Round(Math.Sqrt(n));
            int j;
            for(int i = 2; i <= granica; i++)
            {
             if (tab[i]==true)
                for(j=2*i;j<n;j+=i)
                    tab[j] = false;
            }
        }

        static void WypiszPierwsze(bool[] tab,int n)
        {
            Console.WriteLine("Liczby pierwsze to:");
            int i = 2;
            do {
                if (tab[i] == true) Console.Write(String.Format("{0}, ",i));
                //lub prościej
                //Console.Write(i+", ");
                i++;
            }
            while (i < n);
        }
        static void Main(string[] args)
        {
            Console.Write("Podaj rozmiar tablicy n=");
            n=int.Parse(Console.ReadLine());
            //buduj tablice o podanym rozmiarze n
            //rozmiar n jest jednocześnie zakresem szukania liczb pierwszych
            t = new bool[n];
            //przypisz wartości true każdemu elemntowi tablicy
            for (int i = 0; i < n; i++) t[i] = true;
            Wykreslaj(t,n);
            //pokaz liczby pierwsze z podanego zakresu
            WypiszPierwsze(t,n);
            Console.ReadKey();
        }
    }
}